 list;ignore
 ;---------------------------------------------------------------------
 ; CONTROL:
 ;	file		convert.inc
 ;	author		wouter van ooijen <wf@xs4all.nl>
 ; 	version		1.0
 ; 	date		05-09-1997
 ; 	language	MPASM assembler for Microchip PIC processors
 ;      summary         various conversion macros
 ;      info            http://www.xs4all.nl/~wf/wouter/pic/wloader
 ;---------------------------------------------------------------------
 nolist
 ; Copyright (C) 2000 Wouter van Ooijen
 ;
 ; This application is free software; you can redistribute it and/or
 ; modify it under the terms of the GNU Library General Public
 ; License as published by the Free Software Foundation; either
 ; version 2 of the License, or (at your option) any later version.
 ;
 ; This library is distributed in the hope that it will be useful,
 ; but WITHOUT ANY WARRANTY; without even the implied warranty of
 ; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 ; Library General Public License for more details.
 ; 
 ; You should have received a copy of the GNU Library General Public
 ; License along with this library; if not, write to the
 ; Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 ; Boston, MA  02111-1307, USA.
 ;---------------------------------------------------------------------	
 listing -1

; to_do
; need 'port' in port.inc
; seven_one_busy_show
; seven_two_busy_show
; seven_one_busy_show_combined
; seven_two_busy_show_combined port, pin, pin, f1, f2
; all: polarity, order!
; seven_w_hex_to_seven
; seven_w_dec_to_seven
; seven_w_to_two_hex
; seven_w_to_one_hex
; seven_w_to_one_dec
; seven_w_to_two_dec
; seven_w_to_three_dec

; convert w to two hex values in w, high nibble first
convert_w_to_hl_hex macro
 local same = 1
 local w = 0
 cblock
  _file_1#v($)
 endc
 local temp = _file_1#v($)
 local do_it
 movwf temp
 call do_it
 swapf temp, same
do_it
 swapf temp, w
 andlw H'0F'
 endm

; convert w to two hex values, low nibble first
convert_w_to_lh_hex macro
 local same = 1
 local w = 0
 cblock
  _file_1#v($)
 endc
 local temp = _file_1#v($)
 local do_it
 movwf temp
 call do_it
 swapf temp, w
do_it
 andlw H'0F'
 endm

; convert w to two decimal values, high first
; w should be < 100
convert_w_to_hl_dec macro
 endm

; convert w to two decimal values, low first
; w should be < 100
convert_w_to_lh_dec macro
 endm

; convert w to three decimal values, high first
convert_w_to_hml_dec macro
 endm

; convert w to two decimal values, low first
convert_w_to_lmh_dec macro
 endm

; convert value of w to ascii
; w should be < D'10'
; the only advantage of this macro over the instruction
; itself might be the improved self-documentation.
convert_w_dec_to_ascii macro
 addlw '0'
 endm 

; convert ascii char in w to its hex value
; w should be 'A' <= w <= 'F' or w <= '9'
; carry is set if w <= '0'
convert_w_ascii_to_hex macro
 addlw 0 - 'A'		; to get a carry for A..F
 skpnc			; got a carry?
  addlw '9' + 1 - 'A' 	; yes, add 9+1 .. F offset
 addlw 'A' - '0'		; 'add' remaining offset for '0'
 endm

; convert value of w to ascii
; w should be < D'16'
convert_w_hex_to_ascii macro
 addlw 0 - H'A'	; to get a carry for A..F
 skpnc			; got a carry?
  addlw 'A' - '9' - 1	; yes, add 9+1 .. F offset
 addlw '0' + H'A'	; add remaining offset for '0'
 endm

#define inverse_hex_to_ascii(x) (((x) -'A' + D'10') & H'FF')

; subroutine which converts value of w to 7-segment 
; w should be < D'16'
convert_w_to_7_segment macro polarity
 ;local PCL = 2
 if (polarity == active_high) 
   local inv_mask = H'00'
 else
   local inv_mask = H'FF'
 endif
 addwf PCL, f
 ; segments         -gfedcba
 retlw inv_mask ^ B'00111111' ; 0
 retlw inv_mask ^ B'00000110' ; 1
 retlw inv_mask ^ B'01011011' ; 2
 retlw inv_mask ^ B'01001111' ; 3
 retlw inv_mask ^ B'01100110' ; 4
 retlw inv_mask ^ B'01101101' ; 5
 retlw inv_mask ^ B'01111101' ; 6
 retlw inv_mask ^ B'00000111' ; 7
 retlw inv_mask ^ B'01111111' ; 8
 retlw inv_mask ^ B'01101111' ; 9
 retlw inv_mask ^ B'01110111' ; A (10)
 retlw inv_mask ^ B'01111100' ; B (11)
 retlw inv_mask ^ B'00111001' ; C (12)
 retlw inv_mask ^ B'01011110' ; D (13)
 retlw inv_mask ^ B'01111001' ; E (14)
 retlw inv_mask ^ B'01110001' ; F (15)
 endm

 listing +1
