 list
 ;---------------------------------------------------------------------
 ; CONTROL:
 ;	file		port.inc
 ;	author		wouter van ooijen <wf@xs4all.nl>
 ; 	version		1.1
 ; 	date		09-OCT-2002
 ; 	language	MPASM assembler for Microchip PIC processors
 ;      summary         various input/ouput pin macros and subroutines
 ;      info            http://www.xs4all.nl/~wf/wouter/pic/wloader
 ;---------------------------------------------------------------------
 nolist
 ; Copyright (C) 2000,2002 Wouter van Ooijen
 ;
 ; This application is free software; you can redistribute it and/or
 ; modify it under the terms of the GNU Library General Public
 ; License as published by the Free Software Foundation; either
 ; version 2 of the License, or (at your option) any later version.
 ;
 ; This library is distributed in the hope that it will be useful,
 ; but WITHOUT ANY WARRANTY; without even the implied warranty of
 ; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 ; Library General Public License for more details.
 ; 
 ; You should have received a copy of the GNU Library General Public
 ; License along with this library; if not, write to the
 ; Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 ; Boston, MA  02111-1307, USA.
 ;---------------------------------------------------------------------
 listing -1

; to_do:
; copy value 1->on, 0->off (done)
; idem inverted
; copy literal value (1->1, 0->off)

 ; synonyms for PORTA, ...
 _define porta PORTA
 _define portb PORTB 
 _define portc PORTC
 _define portd PORTD 
 _define porte PORTE 

 ; initially assume all pins are inputs,
 ; beware of port E !
 _set port#v(porta)_tris_value, H'FF'
 _set port#v(portb)_tris_value, H'FF' 
 _set port#v(portc)_tris_value, H'FF' 
 _set port#v(portd)_tris_value, H'FF' 
 _set port#v(porte)_tris_value, H'0F' 

; ; initially assume no port buffers are needed
; _set port#v(porta)_tris_value, H'FF'
; _set port#v(portb)_tris_value, H'FF' 

 ; the values to be used as polarity and 
 ; direction inputs to a.o. port_define
 #define active_high D'1'
 #define active_low  0-D'1'
 #define active_edge D'19'
 #define input       H'11'
 #define output      H'12'
 #define in_out      H'13'
 #define on          D'1'
 #define off         0-D'1'

 ; retrieve what has been defined by port_define
 #define port_port(x)             x#v(0)_port
 #define port_bit(a_x)            a_x#v(0)_bit
 #define port_polarity(a_x)       a_x#v(0)_pol
 #define port_direction(x)        x#v(0)_dir
 #define port_name(a_port,a_bit)  port#v(a_port)bit#v(a_bit)n

 ; define a single pin
port_define macro a_port, a_bit, a_pol, a_dir, a_name
 nolist;ignore
 listing -1
 _define port_name(a_port,a_bit) a_name
 _set a_name#v(0)_port,        a_port
 _set a_name#v(0)_buffer,      port#v(a_port)_output_buffer
 _set a_name#v(0)_tris,        port#v(a_port)_tris_buffer
 _set a_name#v(0)_bit,         a_bit
 _set a_name#v(0)_pol,         a_pol
 _set a_name#v(0)_dir,         a_dir
 _set a_name#v(0)_flush,       port#v(a_port)_flush_buffer
 _set a_name#v(0)_key,         (D'10' * a_port + a_bit)
 ;_define port_direction(a_name) a_dir
 listing +1
 endm

#define if_port_same( a_x, a_y ) if (a_x#v(0)_key == b_x#v(0)_key)

 ; can be done much smarter later...
 listing +100
 cblock
  port#v(porta)_output_buffer
  port#v(portb)_output_buffer
  port#v(portc)_output_buffer
  port#v(portd)_output_buffer
  port#v(porte)_output_buffer
  port#v(porta)_tris_buffer
  port#v(portb)_tris_buffer
  port#v(portc)_tris_buffer
  port#v(portd)_tris_buffer
  port#v(porte)_tris_buffer
 endc
 nolist;ignore
 listing -100

 ; might not always be needed
 listing +100
port#v(porta)_flush_buffer
 movfw port#v(porta)_output_buffer
 movwf porta
 return
port#v(portb)_flush_buffer
 movfw port#v(portb)_output_buffer
 movwf portb
 return
port#v(portc)_flush_buffer
 movfw port#v(portc)_output_buffer
 movwf portc
 return
port#v(portd)_flush_buffer
 movfw port#v(portd)_output_buffer
 movwf portd
 return
port#v(porte)_flush_buffer
 movfw port#v(porte)_output_buffer
 movwf porte
 return
 nolist
 listing -100

; create the subroutines for the defines pins
port_create_tools macro
 nolist
 listing -1
 port_define_tools porta, 0, H'01', port_name(porta,0)
 port_define_tools porta, 1, H'02', port_name(porta,1)
 port_define_tools porta, 2, H'04', port_name(porta,2)
 port_define_tools porta, 3, H'08', port_name(porta,3)
 port_define_tools porta, 4, H'10', port_name(porta,4)
 port_define_tools porta, 5, H'20', port_name(porta,5)
 
 port_define_tools portb, 0, H'01', port_name(portb,0)
 port_define_tools portb, 1, H'02', port_name(portb,1)
 port_define_tools portb, 2, H'04', port_name(portb,2)
 port_define_tools portb, 3, H'08', port_name(portb,3)
 port_define_tools portb, 4, H'10', port_name(portb,4)
 port_define_tools portb, 5, H'20', port_name(portb,5)
 port_define_tools portb, 6, H'40', port_name(portb,6)
 port_define_tools portb, 7, H'80', port_name(portb,7)
 
 port_define_tools portc, 0, H'01', port_name(portc,0)
 port_define_tools portc, 1, H'02', port_name(portc,1)
 port_define_tools portc, 2, H'04', port_name(portc,2)
 port_define_tools portc, 3, H'08', port_name(portc,3)
 port_define_tools portc, 4, H'10', port_name(portc,4)
 port_define_tools portc, 5, H'20', port_name(portc,5)
 port_define_tools portc, 6, H'40', port_name(portc,6)
 port_define_tools portc, 7, H'80', port_name(portc,7)
 
 port_define_tools portd, 0, H'01', port_name(portd,0)
 port_define_tools portd, 1, H'02', port_name(portd,1)
 port_define_tools portd, 2, H'04', port_name(portd,2)
 port_define_tools portd, 3, H'08', port_name(portd,3)
 port_define_tools portd, 4, H'10', port_name(portd,4)
 port_define_tools portd, 5, H'20', port_name(portd,5)
 port_define_tools portd, 6, H'40', port_name(portd,6)
 port_define_tools portd, 7, H'80', port_name(portd,7)
 
 port_define_tools porte, 0, H'01', port_name(porte,0)
 port_define_tools porte, 1, H'02', port_name(porte,1)
 port_define_tools porte, 2, H'04', port_name(porte,2)
 listing +1
 endm

; create the subroutines for the specified pin
port_define_tools macro a_port, a_bit, a_mask, a_name
  ;messg p=a_port b=a_bit n=a_name pp=port_port(a_name)
  _ifdef a_name#v(0)_port

    ; can it be output?
    if (a_name#v(0)_dir != input)

      if (a_name#v(0)_pol == active_edge)

        ; create toggle routine
        _equ a_name#v(0)_toggle, $
        _equ a_name#v(0)_mask, a_mask
        _equ a_name#v(0)_port, a_port 
        listing +100
        movlw a_mask
         xorwf port#v(a_port)_output_buffer, f
         goto port#v(a_port)_flush_buffer
        nolist;ignore
        listing -100

      else

        ; create bit set & clear routines
        _equ a_name#v(0)_set_value_#v(on+2), $
        listing +100
        bsf port#v(a_port)_output_buffer, a_bit
        goto port#v(a_port)_flush_buffer
        nolist
        listing -100

        _equ a_name#v(0)_set_value_#v(off+2), $
        listing +100
        bcf port#v(a_port)_output_buffer, a_bit
        goto port#v(a_port)_flush_buffer
        nolist
        listing -100

     endif

   endif

   ; is it intially output?
   if (a_name#v(0)_dir == output)
   
     ; update tris value
     _set port#v(a_port)_tris_value, port#v(a_port)_tris_value & (~ a_mask)

   endif

   ; is it in_out?
  if (a_name#v(0)_dir == in_out)   

     ; create set direction routines
     _equ a_name#v(0)_set_direction_#v(input), $
     listing +100
     bsf port#v(a_port)_tris_buffer, a_name#v(0)_bit
     movfw port#v(a_port)_tris_buffer
     nolist
     listing -100
     errorlevel -224
     listing +100

     bsf STATUS, RP0
     movwf a_port
     bcf STATUS, RP0

     nolist
     listing -100
     errorlevel +224
     listing +100
     return
     nolist
     listing -100
     _equ a_name#v(0)_set_direction_#v(output), $
     listing +100
     bcf port#v(a_port)_tris_buffer, a_name#v(0)_bit 
     movfw port#v(a_port)_tris_buffer
     nolist
     listing -100
     errorlevel -224
     listing +100

     bsf STATUS, RP0
     movwf a_port
     bcf STATUS, RP0

     nolist
     listing -100
     errorlevel +224
     listing +100
     return
     nolist
     listing -100
         
  endif

  _endif
  endm

port_toggle macro name
 listing +100
 call name#v(0)_toggle
 nolist
 listing -100
 endm

port_toggle_inline macro a_name
 listing +100
 movlw a_name#v(0)_mask
 xorwf a_name#v(0)_buffer, f
 movfw a_name#v(0)_buffer
 movwf a_name#v(0)_port
 nolist
 listing -100
 endm

port_set_value macro name, value
 listing +100
 call name#v(0)_set_value_#v(2 + value * name#v(0)_pol)
 nolist
 listing -100
 endm

port_set_value_from macro a_name, file, bit
 if (a_name#v(0)_pol == active_high)
  listing +100
  bcf a_name#v(0)_buffer, a_name#v(0)_bit
  btfsc file, bit
   bsf a_name#v(0)_buffer, a_name#v(0)_bit
  nolist
  listing -100
 else
 listing +100
  bsf a_name#v(0)_buffer, a_name#v(0)_bit
  btfsc file, bit
   bcf a_name#v(0)_buffer, a_name#v(0)_bit
  nolist
  listing -100
 endif
  listing +100
  call a_name#v(0)_flush
  nolist
  listing -100
 endm

port_set_value_from_inverted macro a_name, file, bit
 if (a_name#v(0)_pol == active_low)
  listing +100
  bcf a_name#v(0)_buffer, a_name#v(0)_bit
  btfsc file, bit
   bsf a_name#v(0)_buffer, a_name#v(0)_bit
  nolist
  listing -100
 else
  listing +100
  bsf a_name#v(0)_buffer, a_name#v(0)_bit
  btfsc file, bit
   bcf a_name#v(0)_buffer, a_name#v(0)_bit
  nolist
  listing -100
 endif
  listing +100
  call a_name#v(0)_flush
  nolist
  listing -100
 endm

port_set_direction macro name, value
 listing +100
 call name#v(0)_set_direction_#v(value)
 nolist
 listing -100
 endm

if_port_value macro a_name, value
 local _port = a_name#v(0)_port
 local _bit = a_name#v(0)_bit
 if (a_name#v(0)_pol == active_high) == (value == on)
  listing +100
  btfsc _port, _bit
  nolist
  listing -100
 else
  listing +100
  btfss _port, _bit
  nolist
  listing -100
 endif
 endm

port_init_port macro a_port
 listing +100
 movlw port#v(a_port)_tris_value
 movwf port#v(a_port)_tris_buffer
 nolist
 listing -100
 if (port#v(a_port)_tris_value != H'FF')
   errorlevel -224
   listing +100

     bsf STATUS, RP0
     movwf a_port
     bcf STATUS, RP0

   nolist
   listing -100
   errorlevel +224
 endif
 endm

port_init macro
 port_init_port porta
 port_init_port portb
 port_init_port portc
 port_init_port portd
 port_init_port porte
 endm

 listing +1
